<template>
    <form class="news__top--right animated fadeInRight">
        <div class="top__right--lang">
            <div class="lang--flex">
                <a href="#" class="element-lang" :class="{activeLang: lang === locale}" v-for="(langData, lang) in locales" @click="locale = lang">
                    {{ lang }}
                    <img :src="`/img/${lang}.png`" alt="" style="margin-left: 5px;">
                </a>
            </div>
            <div class="checkbox-red">
                <p class="text-check">{{ $t('posts.form.important') }}</p>
                <input type="checkbox" class="checkbox" id="check" v-model="form.is_important" />
                <label for="check"></label>
            </div>
        </div>
        <form action="" @submit.prevent="submit">
            <div class="right__input--flex">
                <div class="input--element">
                    <label for="form_title">{{ $t('posts.form.subject') }}</label>
                    <input id="form_title" class="nameEditVal" type="text" v-model="form.title[locale]" required />
                </div>
                <div class="input--element">
                    <label for="form_description">{{ $t('posts.form.description') }}</label>
                    <input id="form_description" class="description" type="text" v-model="form.description[locale]" required />
                </div>
                <div class="input--element">
                    <label for="form_keywords">{{ $t('posts.form.keywords') }}</label>
                    <input id="form_keywords" type="text" v-model="form.keywords" required />
                </div>
            </div>
            <toast-editor v-model="form.body[locale]"/>
            <div class="box-addImg">
                <div class="box__addImg--left">
                    <div class="box-upload">
                        <input id="openFileDialog" ref="fileInput" type="file" @change="uploadFile" hidden>
                        <label for="openFileDialog" >
                            <svg>
                                <use xlink:href="/img/sprite.svg#paperclip"></use>
                            </svg>
                            {{ $t('ui.form.file') }}
                        </label>
                    </div>
                    <div class="list-addImg" v-if="file">
                        <div class="box__addImg--element" @click="deleteFile">
                            <svg>
                                <use xlink:href="/img/sprite.svg#cancel-button" ></use>
                            </svg>
                            <span class="imgEditVal" style="display: block">{{ file.name }}</span>
                        </div>
                    </div>
                </div>
                <div class="box__addImg--right">
                    <p class="text-blue">{{ $t('posts.form.preview') }}</p>
                    <input type="checkbox" class="checkbox" id="check2" v-model="preview"/>
                    <label for="check2"></label>
                </div>
            </div>
            <div class="box__addLink">
                <p class="text-or"><span>{{ $t('posts.form.image_or') }}</span>{{ $t('posts.form.image_link') }}</p>
                <input type="text" v-model="form.file_url">
            </div>
            <button class="btn-edit" type="submit">{{ $t('posts.form.submit') }}</button>
        </form>
    </form>
</template>

<script>
    import {mapGetters} from "vuex";

    export default {
		name: "PostForm",
        props: ['post'],
        data(){
		    return {
		        form: {
                    id: this.post ? this.post.id : undefined,
                    title: this.post ? this.post.title : {},
                    description: this.post ? this.post.description : {},
                    keywords: this.post ? this.post.keywords : '',
                    body: this.post ? this.post.body : {},
                    is_important: this.post ? this.post.is_important : 0,
                    file_url: this.post ? this.post.file_url : '',
                },
                locale: this.app_locale,
                file: undefined,
                preview: false,
            }
        },
        computed: {
            ...mapGetters({
                locales: 'supportedLocales',
                app_locale: 'locale'
            })
        },
        methods: {
            deleteFile() {
                this.$refs.fileInput.type = 'text';
                this.$refs.fileInput.type = 'file';
                this.file = null;
            },
            uploadFile(e) {
                if(e.target.files.length){
                    this.file = e.target.files[0];
                    console.log(this.file);
                }else{
                    this.file = null
                }
            },
            submit(){
                let formData = this.form;
                if(this.file){
                    formData = new FormData;
                    Object.keys(this.form).forEach(key => {
                    	if(['title', 'description', 'body'].includes(key)){
							Object.keys(this.form[key]).forEach(lang => {
								formData.append(`${key}[${lang}]`, this.form[key][lang]);
							});
						}else{
							formData.append(key, this.form[key]);
						}
                    });
                    formData.append('file', this.file);
                }
                this.$emit('submit', formData);
            }
        },
		created() {
			this.locale = this.app_locale;
		}
	}
</script>

<style scoped>
    .box-upload{
        cursor: pointer;
    }
</style>
